// This is the C header file.  It contains the prototypes and constants that
// are used in the runtime routines.  The ifndef/define lines below provide an
// interlock so that the contents of this file will be parsed exactly once
// even if it is #included in more than one place within the same source file.

// How to use this file:  Be sure to #include it before library.c.  See the
// example source files.  Only #include library.c once, but #include this file
// in any other source files that contain calls to kernel extensions.

// the following are useful to transform a 32-bit xaddr into separate 16-bit addr, page
#ifndef XADDR_TO_ADDR
#define XADDR_TO_ADDR(xaddress)    ((uint) (0xFFFF & (xaddress)))
#define XADDR_TO_PAGE(xaddress)    ((int) (0xFF & ((xaddress)>>16)))

#endif  //   XADDR_TO_ADDR

#ifndef __KERNEL_EXTENSION_HEADER_FILE__  // The #endif will be in the postamble file
#define __KERNEL_EXTENSION_HEADER_FILE__

// ----Beginning of package memory allocation listing----
// Package GUI_Toolkit_QSC_v1.93  Code: 070000 - 07345a Vars: 008e00 - 008e0a
// Package Umod_dvr_v1.41         Code: 07345c - 073a2f Vars: 008e0c - 008e0e
// ----End of package memory allocation listing----
#pragma option nowarn=dup
#asm
.VarStart:  equ  $8e0e
#endasm
#pragma option warn=dup
// Variables for Kernel Extension Package: GUI_Toolkit_QSC
// Symbols for Kernel Extension Package: GUI_Toolkit_QSC
#define                                       UPDATE_HERE_WITH_XADDR   0x070166
#define                                        UPDATE_HERE_WITH_PAGE   0x0007
#define                                        UPDATE_HERE_WITH_ADDR   0x0166
#define                                        UPDATE_GRAPHICS_XADDR   0x0701aa
#define                                         UPDATE_GRAPHICS_PAGE   0x0007
#define                                         UPDATE_GRAPHICS_ADDR   0x01aa
#define                                            UPDATE_TEXT_XADDR   0x0701d1
#define                                             UPDATE_TEXT_PAGE   0x0007
#define                                             UPDATE_TEXT_ADDR   0x01d1
#define                               UPDATE_TEXT_AND_GRAPHICS_XADDR   0x0701f8
#define                                UPDATE_TEXT_AND_GRAPHICS_PAGE   0x0007
#define                                UPDATE_TEXT_AND_GRAPHICS_ADDR   0x01f8
#define                                         CLEAR_GRAPHICS_XADDR   0x070202
#define                                          CLEAR_GRAPHICS_PAGE   0x0007
#define                                          CLEAR_GRAPHICS_ADDR   0x0202
#define                                             CLEAR_TEXT_XADDR   0x070229
#define                                              CLEAR_TEXT_PAGE   0x0007
#define                                              CLEAR_TEXT_ADDR   0x0229
#define                                     SET_TEXT_HOME_ADDR_XADDR   0x070256
#define                                      SET_TEXT_HOME_ADDR_PAGE   0x0007
#define                                      SET_TEXT_HOME_ADDR_ADDR   0x0256
#define                                       SET_GR_HOME_ADDR_XADDR   0x070266
#define                                        SET_GR_HOME_ADDR_PAGE   0x0007
#define                                        SET_GR_HOME_ADDR_ADDR   0x0266
#define                                          SET_TEXT_AREA_XADDR   0x070276
#define                                           SET_TEXT_AREA_PAGE   0x0007
#define                                           SET_TEXT_AREA_ADDR   0x0276
#define                                            SET_GR_AREA_XADDR   0x070286
#define                                             SET_GR_AREA_PAGE   0x0007
#define                                             SET_GR_AREA_ADDR   0x0286
#define                                       SET_DISPLAY_MODE_XADDR   0x070296
#define                                        SET_DISPLAY_MODE_PAGE   0x0007
#define                                        SET_DISPLAY_MODE_ADDR   0x0296
#define                                       SET_CURSOR_STATE_XADDR   0x0702af
#define                                        SET_CURSOR_STATE_PAGE   0x0007
#define                                        SET_CURSOR_STATE_ADDR   0x02af
#define                                      SET_DISPLAY_STATE_XADDR   0x0702f2
#define                                       SET_DISPLAY_STATE_PAGE   0x0007
#define                                       SET_DISPLAY_STATE_ADDR   0x02f2
#define                                          SET_TEXT_MODE_XADDR   0x070335
#define                                           SET_TEXT_MODE_PAGE   0x0007
#define                                           SET_TEXT_MODE_ADDR   0x0335
#define                                         CONFIG_DISPLAY_XADDR   0x070345
#define                                          CONFIG_DISPLAY_PAGE   0x0007
#define                                          CONFIG_DISPLAY_ADDR   0x0345
#define                                           INIT_DISPLAY_XADDR   0x0703b1
#define                                            INIT_DISPLAY_PAGE   0x0007
#define                                            INIT_DISPLAY_ADDR   0x03b1
#define                                            STD_DISPLAY_XADDR   0x070546
#define                                             STD_DISPLAY_PAGE   0x0007
#define                                             STD_DISPLAY_ADDR   0x0546
#define                                           DRAW_GRAPHIC_XADDR   0x0705af
#define                                            DRAW_GRAPHIC_PAGE   0x0007
#define                                            DRAW_GRAPHIC_ADDR   0x05af
#define                                    DIRECT_DRAW_GRAPHIC_XADDR   0x07060b
#define                                     DIRECT_DRAW_GRAPHIC_PAGE   0x0007
#define                                     DIRECT_DRAW_GRAPHIC_ADDR   0x060b
#define                                   DIRECT_ERASE_GRAPHIC_XADDR   0x0706a6
#define                                    DIRECT_ERASE_GRAPHIC_PAGE   0x0007
#define                                    DIRECT_ERASE_GRAPHIC_ADDR   0x06a6
#define                                          ERASE_GRAPHIC_XADDR   0x070755
#define                                           ERASE_GRAPHIC_PAGE   0x0007
#define                                           ERASE_GRAPHIC_ADDR   0x0755
#define                                             DO_GRAPHIC_XADDR   0x0707b5
#define                                              DO_GRAPHIC_PAGE   0x0007
#define                                              DO_GRAPHIC_ADDR   0x07b5
#define                                   BUTTON_DRAW_TEXTONLY_XADDR   0x0708eb
#define                                    BUTTON_DRAW_TEXTONLY_PAGE   0x0007
#define                                    BUTTON_DRAW_TEXTONLY_ADDR   0x08eb
#define                                            BUTTON_DRAW_XADDR   0x0709bf
#define                                             BUTTON_DRAW_PAGE   0x0007
#define                                             BUTTON_DRAW_ADDR   0x09bf
#define                                  BUTTON_ERASE_TEXTONLY_XADDR   0x070a34
#define                                   BUTTON_ERASE_TEXTONLY_PAGE   0x0007
#define                                   BUTTON_ERASE_TEXTONLY_ADDR   0x0a34
#define                                           BUTTON_ERASE_XADDR   0x070ac9
#define                                            BUTTON_ERASE_PAGE   0x0007
#define                                            BUTTON_ERASE_ADDR   0x0ac9
#define                                           BUTTON_PRESS_XADDR   0x070b3e
#define                                            BUTTON_PRESS_PAGE   0x0007
#define                                            BUTTON_PRESS_ADDR   0x0b3e
#define                                          BUTTON_REPEAT_XADDR   0x070c30
#define                                           BUTTON_REPEAT_PAGE   0x0007
#define                                           BUTTON_REPEAT_ADDR   0x0c30
#define                                         BUTTON_RELEASE_XADDR   0x070c64
#define                                          BUTTON_RELEASE_PAGE   0x0007
#define                                          BUTTON_RELEASE_ADDR   0x0c64
#define                                              DO_BUTTON_XADDR   0x070d26
#define                                               DO_BUTTON_PAGE   0x0007
#define                                               DO_BUTTON_ADDR   0x0d26
#define                                                DO_MENU_XADDR   0x070e74
#define                                                 DO_MENU_PAGE   0x0007
#define                                                 DO_MENU_ADDR   0x0e74
#define                                           MENU_INSTALL_XADDR   0x070f28
#define                                            MENU_INSTALL_PAGE   0x0007
#define                                            MENU_INSTALL_ADDR   0x0f28
#define                                            MENU_REMOVE_XADDR   0x070fc9
#define                                             MENU_REMOVE_PAGE   0x0007
#define                                             MENU_REMOVE_ADDR   0x0fc9
#define                                              INIT_MENU_XADDR   0x071031
#define                                               INIT_MENU_PAGE   0x0007
#define                                               INIT_MENU_ADDR   0x1031
#define                                            UNINIT_MENU_XADDR   0x071070
#define                                             UNINIT_MENU_PAGE   0x0007
#define                                             UNINIT_MENU_ADDR   0x1070
#define                                              SET_PIXEL_XADDR   0x07110f
#define                                               SET_PIXEL_PAGE   0x0007
#define                                               SET_PIXEL_ADDR   0x110f
#define                                            CLEAR_PIXEL_XADDR   0x07114c
#define                                             CLEAR_PIXEL_PAGE   0x0007
#define                                             CLEAR_PIXEL_ADDR   0x114c
#define                                             IS_PRESSED_XADDR   0x07158a
#define                                              IS_PRESSED_PAGE   0x0007
#define                                              IS_PRESSED_ADDR   0x158a
#define                                         WAIT_FOR_PRESS_XADDR   0x07159a
#define                                          WAIT_FOR_PRESS_PAGE   0x0007
#define                                          WAIT_FOR_PRESS_ADDR   0x159a
#define                                       WAIT_FOR_RELEASE_XADDR   0x0715bb
#define                                        WAIT_FOR_RELEASE_PAGE   0x0007
#define                                        WAIT_FOR_RELEASE_ADDR   0x15bb
#define                                       READ_TOUCHSCREEN_XADDR   0x0715f9
#define                                        READ_TOUCHSCREEN_PAGE   0x0007
#define                                        READ_TOUCHSCREEN_ADDR   0x15f9
#define                                        READ_RAW_COORDS_XADDR   0x071676
#define                                         READ_RAW_COORDS_PAGE   0x0007
#define                                         READ_RAW_COORDS_ADDR   0x1676
#define                                  CALIBRATE_TOUCHSCREEN_XADDR   0x0716c6
#define                                   CALIBRATE_TOUCHSCREEN_PAGE   0x0007
#define                                   CALIBRATE_TOUCHSCREEN_ADDR   0x16c6
#define                                        GLOBALIZE_TVARS_XADDR   0x072572
#define                                         GLOBALIZE_TVARS_PAGE   0x0007
#define                                         GLOBALIZE_TVARS_ADDR   0x2572
#define                                        SCREEN_TO_IMAGE_XADDR   0x072582
#define                                         SCREEN_TO_IMAGE_PAGE   0x0007
#define                                         SCREEN_TO_IMAGE_ADDR   0x2582
#define                                       GRAPHIC_TO_IMAGE_XADDR   0x072841
#define                                        GRAPHIC_TO_IMAGE_PAGE   0x0007
#define                                        GRAPHIC_TO_IMAGE_ADDR   0x2841
#define                                         SIMULATE_TOUCH_XADDR   0x072b46
#define                                          SIMULATE_TOUCH_PAGE   0x0007
#define                                          SIMULATE_TOUCH_ADDR   0x2b46
#define                                     SCREEN_HAS_CHANGED_XADDR   0x072c4e
#define                                      SCREEN_HAS_CHANGED_PAGE   0x0007
#define                                      SCREEN_HAS_CHANGED_ADDR   0x2c4e
#define                                     HAS_SCREEN_CHANGED_XADDR   0x072c58
#define                                      HAS_SCREEN_CHANGED_PAGE   0x0007
#define                                      HAS_SCREEN_CHANGED_ADDR   0x2c58
#define                               SIMULATED_TOUCH_TO_IMAGE_XADDR   0x072c5f
#define                                SIMULATED_TOUCH_TO_IMAGE_PAGE   0x0007
#define                                SIMULATED_TOUCH_TO_IMAGE_ADDR   0x2c5f
#define                                          SERVICE_TOUCH_XADDR   0x072cfe
#define                                           SERVICE_TOUCH_PAGE   0x0007
#define                                           SERVICE_TOUCH_ADDR   0x2cfe
#define                                           MENU_PROCESS_XADDR   0x072eef
#define                                            MENU_PROCESS_PAGE   0x0007
#define                                            MENU_PROCESS_ADDR   0x2eef
#define                                WAIT_THEN_SERVICE_TOUCH_XADDR   0x072ef3
#define                                 WAIT_THEN_SERVICE_TOUCH_PAGE   0x0007
#define                                 WAIT_THEN_SERVICE_TOUCH_ADDR   0x2ef3
#define                                             MENU_QUERY_XADDR   0x0730f4
#define                                              MENU_QUERY_PAGE   0x0007
#define                                              MENU_QUERY_ADDR   0x30f4
#define                                             INIT_TOUCH_XADDR   0x0730f8
#define                                              INIT_TOUCH_PAGE   0x0007
#define                                              INIT_TOUCH_ADDR   0x30f8
#define                                  RENDER_FONT_TO_BUFFER_XADDR   0x073199
#define                                   RENDER_FONT_TO_BUFFER_PAGE   0x0007
#define                                   RENDER_FONT_TO_BUFFER_ADDR   0x3199
#define                                            RENDER_FONT_XADDR   0x0732c4
#define                                             RENDER_FONT_PAGE   0x0007
#define                                             RENDER_FONT_ADDR   0x32c4
#define                                     DIRECT_RENDER_FONT_XADDR   0x0732d8
#define                                      DIRECT_RENDER_FONT_PAGE   0x0007
#define                                      DIRECT_RENDER_FONT_ADDR   0x32d8
// Variables for Kernel Extension Package: Umod_dvr
// Symbols for Kernel Extension Package: Umod_dvr
#define                                        RS485_XMIT_UART_XADDR   0x073641
#define                                         RS485_XMIT_UART_PAGE   0x0007
#define                                         RS485_XMIT_UART_ADDR   0x3641
#define                                         RS485_RCV_UART_XADDR   0x073662
#define                                          RS485_RCV_UART_PAGE   0x0007
#define                                          RS485_RCV_UART_ADDR   0x3662
#define                                   LOOP_UNTIL_XMIT_DONE_XADDR   0x073689
#define                                    LOOP_UNTIL_XMIT_DONE_PAGE   0x0007
#define                                    LOOP_UNTIL_XMIT_DONE_ADDR   0x3689
#define                                   WAIT_UNTIL_XMIT_DONE_XADDR   0x0736a2
#define                                    WAIT_UNTIL_XMIT_DONE_PAGE   0x0007
#define                                    WAIT_UNTIL_XMIT_DONE_ADDR   0x36a2
#define                               RS485_RCV_WHEN_XMIT_DONE_XADDR   0x0736c4
#define                                RS485_RCV_WHEN_XMIT_DONE_PAGE   0x0007
#define                                RS485_RCV_WHEN_XMIT_DONE_ADDR   0x36c4
#define                                             SEND_BREAK_XADDR   0x07370b
#define                                              SEND_BREAK_PAGE   0x0007
#define                                              SEND_BREAK_ADDR   0x370b
#define                                              END_BREAK_XADDR   0x073721
#define                                               END_BREAK_PAGE   0x0007
#define                                               END_BREAK_ADDR   0x3721
#define                                                 IS_DTR_XADDR   0x073731
#define                                                  IS_DTR_PAGE   0x0007
#define                                                  IS_DTR_ADDR   0x3731
#define                                                 IS_RTS_XADDR   0x07374a
#define                                                  IS_RTS_PAGE   0x0007
#define                                                  IS_RTS_ADDR   0x374a
#define                                               READ_CTS_XADDR   0x073763
#define                                                READ_CTS_PAGE   0x0007
#define                                                READ_CTS_ADDR   0x3763
#define                                               READ_DSR_XADDR   0x07377c
#define                                                READ_DSR_PAGE   0x0007
#define                                                READ_DSR_ADDR   0x377c
#define                                               READ_DCD_XADDR   0x073795
#define                                                READ_DCD_PAGE   0x0007
#define                                                READ_DCD_ADDR   0x3795
#define                                        SET_UART_NUMBER_XADDR   0x0737ae
#define                                         SET_UART_NUMBER_PAGE   0x0007
#define                                         SET_UART_NUMBER_ADDR   0x37ae
#define                                       READ_UART_NUMBER_XADDR   0x0737b5
#define                                        READ_UART_NUMBER_PAGE   0x0007
#define                                        READ_UART_NUMBER_ADDR   0x37b5
#define                                               SET_BAUD_XADDR   0x0737bc
#define                                                SET_BAUD_PAGE   0x0007
#define                                                SET_BAUD_ADDR   0x37bc
#define                                        SET_DATA_FORMAT_XADDR   0x073824
#define                                         SET_DATA_FORMAT_PAGE   0x0007
#define                                         SET_DATA_FORMAT_ADDR   0x3824
#define                                          SET_PROTOCOLS_XADDR   0x07387c
#define                                           SET_PROTOCOLS_PAGE   0x0007
#define                                           SET_PROTOCOLS_ADDR   0x387c
#define                                              EMIT_UART_XADDR   0x073981
#define                                               EMIT_UART_PAGE   0x0007
#define                                               EMIT_UART_ADDR   0x3981
#define                                           ASK_KEY_UART_XADDR   0x0739a9
#define                                            ASK_KEY_UART_PAGE   0x0007
#define                                            ASK_KEY_UART_ADDR   0x39a9
#define                                               KEY_UART_XADDR   0x0739b9
#define                                                KEY_UART_PAGE   0x0007
#define                                                KEY_UART_ADDR   0x39b9
#define                                               CH1_EMIT_XADDR   0x0739e1
#define                                                CH1_EMIT_PAGE   0x0007
#define                                                CH1_EMIT_ADDR   0x39e1
#define                                               CH2_EMIT_XADDR   0x0739ee
#define                                                CH2_EMIT_PAGE   0x0007
#define                                                CH2_EMIT_ADDR   0x39ee
#define                                            CH1_ASK_KEY_XADDR   0x0739fb
#define                                             CH1_ASK_KEY_PAGE   0x0007
#define                                             CH1_ASK_KEY_ADDR   0x39fb
#define                                            CH2_ASK_KEY_XADDR   0x073a08
#define                                             CH2_ASK_KEY_PAGE   0x0007
#define                                             CH2_ASK_KEY_ADDR   0x3a08
#define                                                CH1_KEY_XADDR   0x073a15
#define                                                 CH1_KEY_PAGE   0x0007
#define                                                 CH1_KEY_ADDR   0x3a15
#define                                                CH2_KEY_XADDR   0x073a22
#define                                                 CH2_KEY_PAGE   0x0007
#define                                                 CH2_KEY_ADDR   0x3a22

// Beginning C Header file for package: GUI_Toolkit_QSC
#define USING_QSC -1
// GUI Tools-- These #defines provide an interface between the GUI Toolkit
// and the programmer.  Information can be found in the GUI Toolkit manual.

#include <mosaic/gui_tk/to_large.h>

#ifndef __QED_GUI_TOOLS__
#define __QED_GUI_TOOLS__

#define __QED_GUI_TOOLS_VERSION__ 1.7

#define TVARS &tvars, 0

#define DRAW_MASK (GRAPHICS_MASK | DRAW_TEXTONLY_ACTION |\
ERASE_TEXTONLY_ACTION)
// BEGIN Macros

// Builds a button from the given parameters.   The text defined
// in quotes should also be on the page specified as GUI_STRINGS_PAGE
// (or in common RAM).  That shouldn't be too much of a problem since
// the strings are copied to each page anyway.


// the following are useful to transform a 32-bit xaddr into separate 16-bit addr, page
#ifndef XADDR_TO_ADDR
#define XADDR_TO_ADDR(xaddress)    ((uint) (0xFFFF & (xaddress)))
#define XADDR_TO_PAGE(xaddress)    ((int) (0xFF & ((xaddress)>>16)))

#endif  //   XADDR_TO_ADDR

// the following is useful to transform a separate 16-bit addr, page into a 32-bit xaddress
#ifndef TO_XADDR
#define TO_XADDR(address,page)     ((xaddr) (((page)<<16)+ (0xFFFF & (address))))

#endif  //   TO_XADDR


#define BLANKBUTTON( flags, draw_graphic,\
release_graphic, press_graphic, press_action,\
release_action, label1, label2, label3, label4, buttonname )\
BUTTON buttonname##_struct_={\
(flags)|C_STYLE_TEXT_FLAG,\
TO_XADDR((DO_GRAPHIC_ADDR),(DO_GRAPHIC_PAGE)),\
draw_graphic,\
release_graphic,\
press_graphic,\
press_action,\
release_action,\
(label1),\
(label2),\
(label3),\
(label4) \
}; BUTTON * buttonname=&buttonname##_struct_


// Builds a graphical button that uses direct screen I/O to handle touchscreen
// presses and releases.  Buttonname is that of the button being
// created.  Flags referes to the configuration flags for the new button.
// Draw_graphic, release_graphic, and press_graphic are pointers to the
// respective graphics.  These are usually generated by pcx2qed, a pc utility
// for generating images from pcx graphics files.  Each of these three graphics
// MUST be defined.  The func_addr is the action to be executed upon press,
// release, or both depending on which configuration flags are set.  The Labels
// are displayed inside the button if the DRAW_TEXT_FLAG is set.

#define FASTBUTTON_FLAGS \
( DRAW_GRAPHIC_FLAG |\
RELEASE_GRAPHIC_FLAG |\
DIR_RELEASE_GRAPHIC_FLAG |\
PRESS_GRAPHIC_FLAG |\
DIR_PRESS_GRAPHIC_FLAG |\
C_STYLE_TEXT_FLAG )

#define FASTBUTTON( flags,\
draw_graphic,\
release_graphic,\
press_graphic,\
action, label1, label2, label3, label4, buttonname )\
BUTTON buttonname##_struct_={\
(flags) | FASTBUTTON_FLAGS,\
TO_XADDR((DO_GRAPHIC_ADDR),(DO_GRAPHIC_PAGE)),\
draw_graphic,\
release_graphic,\
press_graphic,\
action,\
action,\
(label1),\
(label2),\
(label3),\
(label4) \
}; BUTTON * buttonname=&buttonname##_struct_



// Builds a graphical button that uses the graphics_garray to handle graphic
// presses and releases.  Buttonname is the that of the button being
// created.  Flags referes to the configuration flags for the new button.
// Draw_graphic, release_graphic, and press_graphic are pointers to the
// respective graphics.  These are usually generated by pcx2qed, a pc utility
// for generating images from pcx graphics files.  Each of these three graphics
// MUST be defined.  The func_addr is the action to be executed upon press,
// release, or both depending on which configuration flags are set.  The Labels
// are displayed inside the button if the DRAW_TEXT_FLAG is set.

#define NORMBUTTON_FLAGS \
( DRAW_GRAPHIC_FLAG |\
RELEASE_GRAPHIC_FLAG |\
PRESS_GRAPHIC_FLAG |\
C_STYLE_TEXT_FLAG )


#define NORMBUTTON( flags,\
draw_graphic,\
release_graphic,\
press_graphic,\
action, label1, label2, label3, label4, buttonname )\
BUTTON buttonname##_struct_={\
(flags) | NORMBUTTON_FLAGS,\
TO_XADDR((DO_GRAPHIC_ADDR),(DO_GRAPHIC_PAGE)),\
draw_graphic,\
release_graphic,\
press_graphic,\
action,\
action,\
(label1),\
(label2),\
(label3),\
(label4) \
}; BUTTON * buttonname=&buttonname##_struct_


// Menu building macros start here

#define BUTTON_WIDTH    8
#define BUTTON_HEIGHT   32
#define BUTTON_ROWS     4

#if USING_QSC

// this macro slightly differs from the one defined for the paneltouch
#define COLROW_TO_BUTTON( col,row )\
(((col)/BUTTON_WIDTH)*BUTTON_ROWS\
+((row)/BUTTON_HEIGHT)+1)

#else

// this macro slightly differs from the one defined for the Qscreen
#define COLROW_TO_BUTTON( col,row )\
(((col)/BUTTON_WIDTH)*BUTTON_ROWS\
+((row)/BUTTON_HEIGHT))
#endif

#define NEW_MENU MENU_ENTRY


#define SWAP_ADDR_AND_PAGE( address, page ) page, address


// Inserts a graphic into the current menu to be displayed at the screen
// offset of col,row.

#define ADD_GRAPHIC( col, row, action_mask, graphic_obj )\
{ row,\
col,\
(xaddr) graphic_obj,\
TO_XADDR(DO_GRAPHIC_ADDR,DO_GRAPHIC_PAGE),\
action_mask,\
BUTTON_NONLOCAL\
}

// Inserts a button into the current menu to be displayed at the screen
// offset of col,row and the keymap offset (button number) n.

#define ADD_BUTTON( n, col, row, action_mask, button_obj )\
{ row,\
col,\
&button_obj##_struct_,\
TO_XADDR(DO_BUTTON_ADDR,DO_BUTTON_PAGE),\
action_mask,\
n\
}

// Inserts a button into the current menu to be displayed at the screen
// offset of col,row.  The location on the touchscreen is computed
// automatically based on the col,row given.

#define ADD_TOUCH_BUTTON( col, row, action_mask, button_obj )\
{ row,\
col,\
&button_obj##_struct_,\
TO_XADDR(DO_BUTTON_ADDR,DO_BUTTON_PAGE),\
action_mask,\
COLROW_TO_BUTTON( col,row )\
}


// To be placed at the end of a menu to create the Forth array parameter
// field for the C array defined earlier.

//{ { (char *) &(arrayname##_m.xhandle.sixteen_bit.page16),\

#define BUILD_MENU( arrayname, num_elements)\
MENU arrayname##_menu_pf =\
{ { (char *) &(arrayname##_menu_pf.xhandle),\
0,\
sizeof( MENU_ENTRY ),\
1,\
num_elements,\
0,\
0,\
0 },\
(CFORTH_ARRAY *) arrayname\
}; MENU * arrayname##_menu=&arrayname##_menu_pf


// End Macros

#endif      // __QED_GUI_TOOLS__

#include <mosaic/gui_tk/fr_large.h>

// This is the header file for the GUI Software Toolkit.  JLW 4/14/1999

#include <mosaic/gui_tk/to_large.h>

#ifndef __QED_GUI_LIB__
#define __QED_GUI_LIB__

#define __QED_GUI_LIB_VERSION__ 1.7

// Additional type definitions
typedef int     boolean;
// typedef int     addr; // defined in types.h
// typedef int     page;

typedef struct {
    xaddr display_heap_top;         // The top of the display heap being used
    xaddr display_heap_bottom;      // The bottom of the display heap being used
    uint background_fill;           // The contents of this variable are filled
                                    // into the display graphics array when
                                    // clear.graphics is called.  T

    FORTH_ARRAY graphics_garray;    // We need an array for the graphics system
                                    // to use.  This array will be used by the
                                    // graphics calls in the menu system.  It
                                    // may be used by the application code also.

    xaddr display_resource;         // This resource variable manages access to
                                    // the graphics array and hardware.  This
                                    // variable is initialized by
                                    // init.dualmode.display

    uint gr_home_addr;              // Holds the address inside the display
                                    // where the graphics area begins
    uint text_home_addr;            // Holds the address inside the display
                                    // where the text area begins

    uint graphic_rows;              // The number of pixels lines on the display
    uint graphic_cols;              // The number of byte columns on the display
                                    // This depends on the setting of the hard-
                                    // ware Mode A pin on the TC6963 controller
                                    // chip. Not all LCDs bring this pin out,
                                    // but on the standard 240x128 display, it
                                    // is available
                                    // and may be set for either 6 or 8
                                    // pixels/byte.
                                    // This would cause +graphic_cols to have a
                                    // value of either 40 or 30 respectively.

    uint text_rows;                 // The number of text lines on the display
    uint text_cols;                 // The number of text columns

// Menu object globals:

    FORTH_ARRAY keymap_array;
        // The following are provided as an easy means for people to access
        // information about buttons being pressed
    uint current_row;                // The current row of the button pressed
    uint current_col;                // The current col of the button pressed

    uint current_keynum;             // The key index  of the button pressed
    xaddr current_button;            // the xpfa of the button that has just been
                                     // pressed.
#if USING_QSC
// Touchscreen globals:
    uint last_read_time;             // the last time the touchscreen was read
    uint raw_y_coord;                // current uncalibrated y coordinate
    uint raw_x_coord;                // current uncalibrated x coordinate
    uint cal_y_coord;                // current calibrated y coordinate
    uint cal_x_coord;                // current calibrated x coordinate
#endif
// Menu manager globals:
    uint repeat_delay;               // delay time before repeating in TS counts
    uint repeat_period;              // delay between repeat cycles in TS counts
} GUI_VARS;



typedef struct {                // Standard buttons will use this structure
  int flags;                    // the bitmaped flags used by the handler
                                // see above for description


  xaddr graphic_handler_xcfa;   // the xcfa to be EXECUTEd for the graphics
                                // this handler is required to process
                                // the stack picture that will be left for
                                // a graphic object.  It must be a forth
                                // and will be expected to process the the
                                // graphic class of commands.

  xaddr draw_graphic;           // the xpfa of the graphic shown on draw
  xaddr release_graphic;        // the xpfa of the graphic shown on release
  xaddr press_graphic;          // the xpfa of the graphic shown on press


  //page press_handler_page;
  void (*press_handler) ( );    // the xcfa of user code to run when on pressed

  //page release_handler_page;
  void (*release_handler) ( );  // the xcfa of user code to run when on released

                                // The above 2 xcfas may be either C or Forth
                                // given that they do not accept or return
                                // any values.  If there is a need to pass
                                // values  in or out, then global variables must
                                // be used.

        // Now, we include an optional 4 lines text that may be used.
        // These strings are expected to be forth style strings.
        // if this is a problem, then the code will be changed to accomodate
        // C style strings instead.

  char * label4;                 // line 4 text inside button (0-8 characters)
//  page label4_page;
//  char * label4;

  char * label3;                 // line 3 text inside button (0-8 characters)
//  page label3_page;
//  char * label3;

  char * label2;                 // line 2 text inside button (0-8 characters)
//  page label2_page;
//  char * label2;

  char * label1;                 // line 1 text inside button (0-8 characters)
//  page label1_page;
//  char * label4;

} BUTTON;

typedef struct { // Make a new type of structure
  int row;                      // The relative col number for the item
  int col;                      // The relative row number for the item

  BUTTON * obj_xaddr;
  //page object_page;
  //void * object;

  xaddr obj_handler;            // the xcfa of the code that handles the object

// Objects below here are not to be copied into the keymap index array
  uint action_mask;             // A mask to configure which actions may be
                                // passed through to the menu item
  uint button;                  // The relative index for button referencing
                                // +button# must correlate to the graphic
                                // location of the item for touchscreens.
                                // Otherwise, it can simply be used to specify
                                // what element in the keymap array will contain
                                // the item.
} MENU_ENTRY;


typedef struct {
  //page array_ptr_page;
  //char * array_ptr_addr;
  char * array_ptr;
  uint  pfa_currentHeap;
  uint   pfa_bytesPerElement;
  uint   pfa_numdimensions;
  uint   pfa_numCols;
  uint   pfa_numRows;
  uint   pfa_limit2;  // limit2 and limit3 are not used in 2D
  uint   pfa_limit3;  // array, but they must be allocated!
  } CFORTH_ARRAY ;

typedef struct {
  CFORTH_ARRAY arraypf;          // The array parameter field
  CFORTH_ARRAY * xhandle;
  //EXTENDED_ADDR xhandle;
//  page array_page;              // The pointer to the page of the FORTH_ARRAY
//  char * array_addr;            // The pointer to the FORTH_ARRAY
  } FORTH_CONST_ARRAY;

typedef FORTH_CONST_ARRAY MENU;

// Begin Font Stuff
// This is the font structure.  It binds 8 graphic objects into a
// font.  Each graphic object, called a tablet, represents 16 characters.
// Dividing this up makes the shape of the graphics a bit more manageable.
typedef struct {
    xaddr tablet0;
    xaddr tablet1;
    xaddr tablet2;
    xaddr tablet3;
    xaddr tablet4;
    xaddr tablet5;
    xaddr tablet6;
    xaddr tablet7;
    } FONT;

// This macro accepts TVARS and dereferences out the garray from it.
// It is better not to do that in the actual function since so that
// experts may use the low level call to render into an offscreen
// array.  This macro assumes that you want to draw into the onscreen
// GUI buffer.  The other thing this macro does is mark the string as
// a null term string so that Render_Font will know it is coming from C.

#define QUICK_RENDER_FONT(strAddr, column, row, font)\
   (Render_Font(strAddr, (THIS_PAGE+0xFF00), column, row, &tvars, 0, font, (THIS_PAGE)))

// This macro is quite similar to the above, but it must use TVARS since
// it simply direct renders to the LCD.
#define QUICK_DIRECT_RENDER_FONT(strAddr, column, row, font)\
    (Direct_Render_Font(strAddr, (THIS_PAGE+0xFF00), column, row, &tvars, 0, font, (THIS_PAGE)))

// End Font stuff



// ****Automatically generated by JLW forth to C awk script ver 5/5
// This file contains the constants that are defined in a forth program.
// This file was generated on Thu May 06 00:52:36 PDT 1999 by wadejer
// on the machine: circe.procyon.com


// Display configuration constants
#define GRAPHICS_DATA_ADDR                      0x80A0
#define GRAPHICS_CMD_ADDR                       0x80A2
#define AWSET_CMD                               0x00B0
#define AWRESET_CMD                             0x00B2
#define SET_TX_HOME_CMD                         0x0040
#define SET_TX_AREA_CMD                         0x0041
#define SET_GR_HOME_CMD                         0x0042
#define SET_GR_AREA_CMD                         0x0043
#define MODE_CMD                                0x0080
#define DISPLAY_MODE_CMD                        0x0090
#define CURSOR_BLINK                            0x0001
#define CURSOR_ON                               0x0002
#define TEXT_MODE                               0x0004
#define GRAPHICS_MODE                           0x0008
#define LCD_TEXT_ADDR                           0x0000
#define LCD_GRAPHIC_ADDR                        0x0280
#define LINES_PER_CHAR                            0008
#define GRAPHICS_COLUMNS                          0030
#define GRAPHICS_ROWS                             0128
#define TEXT_COLUMNS                              0040
#define TEXT_ROWS                                 0016
// 2015-05-28 Heap location changed; see comment in dualmode.4th
#define DISPLAY_HEAP_TOP                      0x033FFFL
#define DISPLAY_HEAP_BOTTOM                   0x032000L
#define DEF_BACKGROUND_FILL                     0x0000

// Graphic Objects Constants
#define GRAPHICS_MASK                           0x001F
#define DRAW_ACTION                             0x0001
#define DIR_DRAW_ACTION                         0x0002
#define REDRAW_ACTION                           0x0004
#define ERASE_ACTION                            0x0008
#define DIR_ERASE_ACTION                        0x0010

// Button Constants
#define BUTTON_MASK                             0x03E0
#define PRESS_REPEAT_ACTION                     0x0020
#define PRESS_ACTION                            0x0040
#define REL_ACTION                              0x0080
#define DRAW_TEXTONLY_ACTION                    0x0100
#define ERASE_TEXTONLY_ACTION                   0x0200

// Button Flags
#define DRAW_GRAPHIC_FLAG                       0x0001
#define RELEASE_GRAPHIC_FLAG                    0x0002
#define PRESS_GRAPHIC_FLAG                      0x0004
#define DIR_DRAW_GRAPHIC_FLAG                   0x0008
#define DIR_RELEASE_GRAPHIC_FLAG                0x0010
#define DIR_PRESS_GRAPHIC_FLAG                  0x0020
#define DRAW_TEXT_FLAG                          0x0040
#define PRESS_HANDLER_FLAG                      0x0080
#define RELEASE_HANDLER_FLAG                    0x0100
#define REPEAT_FLAG                             0x0200
#define TEXT_UPDATE_PRESS_FLAG                  0x0400
#define TEXT_UPDATE_RELEASE_FLAG                0x0800
#define GRAPHICS_UPDATE_PRESS_FLAG              0x1000
#define GRAPHICS_UPDATE_RELEASE_FLAG            0x2000
#define C_STYLE_TEXT_FLAG                       0x4000
#ifndef BEEP_FLAG
#define BEEP_FLAG                               0x8000
#endif        
// Menu Constants
#define MENU_MASK                               0x0C00
#define INIT_ACTION                             0x0400
#define UNINIT_ACTION                           0x0800
#define BUTTON_NULL                             0xFFFF
#define BUTTON_NONLOCAL                         0xFFFE
#define DEFAULT_REPEAT_PERIOD                   0x0010
#define DEFAULT_REPEAT_DELAY                    0x0080

#endif      // __QED_GUI_LIB__
#include <mosaic/gui_tk/fr_large.h>



extern _forth  void Update_Here_With( addr address,       addr * graphics_resource_addr,       page graphics_resource_page,       FORTH_ARRAY * garray_addr,       page garray_page );

extern _forth  void Update_Graphics ( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Update_Text( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Update_Text_And_Graphics( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Clear_Graphics( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Clear_Text( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Set_Text_Home_Addr( addr address );

extern _forth  void Set_Gr_Home_Addr( addr address );

extern _forth  void Set_Text_Area( uint columns );

extern _forth  void Set_Gr_Area( uint columns );

extern _forth  void Set_Display_Mode( uint columns );

extern _forth  void Set_Cursor_State( boolean isvisible, boolean isflashing );

extern _forth  void Set_Display_State( boolean graphics, boolean text );

extern _forth  void Set_Text_Mode( uchar modebyte );

extern _forth  void Config_Display( uint graphics_cols, uint graphics_rows, addr graphics_start, uchar background_fill, uint text_cols, uint text_rows, addr text_start, xaddr heap_bottom, xaddr heap_top, GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Init_Display( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Std_Display( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Draw_Graphic( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       xaddr graphic_addr );

extern _forth  void Direct_Draw_Graphic( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       xaddr graphic_addr );

extern _forth  void Direct_Erase_Graphic( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       xaddr graphic_addr );

extern _forth  void Erase_Graphic( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       xaddr graphic_addr );

extern _forth  void Do_Graphic ( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       uint action,       xaddr graphic_addr );

extern _forth  void Button_Draw_Textonly( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr );

extern _forth  void Button_Draw( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr );

extern _forth  void Button_Erase_Textonly( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr );

extern _forth  void Button_Erase( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr );

extern _forth  void Button_Press( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr );

extern _forth  void Button_Repeat( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr );

extern _forth  void Button_Release( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       BUTTON * button_addr );

extern _forth  void Do_Button( uint col,       uint row,       GUI_VARS * tvars_addr,       page tvars_page,       uint action,       BUTTON * button_addr );

extern _forth  void Do_Menu(   uint col,   uint row,   GUI_VARS * tvars_addr,   page tvars_page,   uint action,   MENU * menu_addr );

extern _forth  void Menu_Install( uint offset,   uint col,   uint row,   GUI_VARS * tvars_addr,   page tvars_page,   MENU *  menu_addr );

extern _forth  void Menu_Remove(   uint offset,   GUI_VARS * tvars_addr,   page tvars_page,   MENU *  menu_addr );

extern _forth  void Init_Menu(   uint offset,   uint col,   uint row,   GUI_VARS * tvars_addr,   page tvars_page,   MENU * menu_addr );

extern _forth  void Uninit_Menu(   uint offset,   uint col,   uint row,   GUI_VARS * tvars_addr,   page tvars_page,   MENU * menu_addr );

extern _forth  void Set_Pixel ( int x, int y );

extern _forth  void Clear_Pixel(int x, int y);

extern _forth  int Is_Pressed ( void );

extern _forth  void Wait_For_Press ( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Wait_For_Release ( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  int Read_Touchscreen ( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  long Read_Raw_Coords ( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Calibrate_Touchscreen( long raw0, long raw1, long raw2 );

extern _forth  void Globalize_TVars ( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  int Screen_To_Image ( xaddr buffer, int buffer_size, int format );

extern _forth  int Graphic_To_Image ( xaddr graphic, xaddr buffer, int buffer_size, int format );

extern _forth  long Simulate_Touch ( int x, int y );

extern _forth  void Screen_Has_Changed ( void );

extern _forth  int Has_Screen_Changed ( void );

extern _forth  int Simulated_Touch_To_Image ( long buffer, int buffer_size, int format_id, int x, int y );

extern _forth  void Service_Touch( int buttonID, GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Menu_Process(  int buttonID, GUI_VARS * tvars_addr, page tvars_page);

extern _forth  void Wait_Then_Service_Touch( GUI_VARS * tvars_addr, page tvars_page );

extern _forth  void Menu_Query(   GUI_VARS * tvars_addr,   page tvars_page );

extern _forth  void Init_Touch(   GUI_VARS * tvars_addr,   page tvars_page );

extern _forth  void Render_Font_to_buffer(  char * string_addr, page string_page,       uint col,       uint row,       FORTH_ARRAY * garray_addr, page garray_page,       FONT * font_addr,       page font_page);

extern _forth  void Render_Font(  char * string_addr, page string_page,       uint col,       uint row,       GUI_VARS * tvars_addr, page tvars_page,       FONT * font_addr,       page font_page);

extern _forth  void Direct_Render_Font( char * string_addr, page string_page,       uint col,       uint row,       GUI_VARS * tvars_addr,page tvars_page,       FONT * font_addr,       page font_page);

// End of C Header file for package: GUI_Toolkit_QSC

// Beginning C Header file for package: Umod_dvr
// serial channel (port) designators:
#define CHANNEL1     0x01
#define CHANNEL2     0x02

// used to specify protocol:
#define NOT_USED     0x00  // if a channel is not used, it can be powered down
#define RS485        0x21  // must share a set bit with rs422! see Set_Protocols.

// config_reg bit masks, also used to specify protocol (see Set_Protocols):
#define RS422        0x01  // note: rs485 is distinguished from rs422 only by direction_reg
#define RS232        0x02  // bits must be exclusive compared to rs422, rs485

// used to specify parity; numeric values pertain to the line_control_reg:
#define NO_PARITY    0x00     // parity disabled
#define EVEN_PARITY  0x18     // even parity enabled
#define ODD_PARITY   0x08     // odd parity enabled
#define LOW_PARITY   0x38     // parity enabled, parity bit is always 0 at uart
#define HIGH_PARITY  0x28     // parity enabled, parity bit is always 1 at uart

extern _forth  void RS485_Xmit_UART ( int channel_num, int module_num );

extern _forth  void RS485_Rcv_UART ( int channel_num, int module_num );

extern _forth  void Loop_Until_Xmit_Done ( int channel_num, int module_num );

extern _forth  void Wait_Until_Xmit_Done ( int channel_num, int module_num );

extern _forth  void RS485_Rcv_When_Xmit_Done ( int channel_num, int module_num );

extern _forth  void Send_Break ( int channel_num, int module_num );

extern _forth  void End_Break ( int channel_num, int module_num );

extern _forth  void Is_DTR ( int desired_state, int module_num );

extern _forth  void Is_RTS ( int desired_state, int module_num );

extern _forth  int Read_CTS ( int channel_num );

extern _forth  int Read_DSR ( int module_num );

extern _forth  int Read_DCD ( int module_num );

extern _forth  void Set_UART_Number ( int module_num );

extern _forth  int Read_UART_Number ( void );

extern _forth  void Set_Baud ( uint baud, int channel_num, int module_num );

extern _forth  void Set_Data_Format (int numbits, int numStopBits, int parity_code,   int channel_num, int module_num );

extern _forth  int Set_Protocols ( int Ch1_modem_support, int Ch1_protocol,   int Ch2_protocol, int module_num );

extern _forth  void Emit_UART ( uchar character, int channel_num, int module_num );

extern _forth  int Ask_Key_UART ( int channel_num, int module_num );

extern _forth  uchar Key_UART ( int channel_num, int module_num );

extern _forth  void Ch1_Emit ( uchar character );

extern _forth  void Ch2_Emit ( uchar character );

extern _forth  int Ch1_Ask_Key ( void );

extern _forth  int Ch2_Ask_Key ( void );

extern _forth  uchar Ch1_Key ( void );

extern _forth  uchar Ch2_Key ( void );

// End of C Header file for package: Umod_dvr

// This #endif statement closes the block begun at
// the front of the pre
#endif

// *** Note: be sure to #include this file before library.c, and in any other
// source files that use these kernel extension functions.
